/**
 * @file main.cpp
 * @date Jan 30, 2009
 * @author Jonathan Masci
 */

#include "golombCoding.h"
#include <fstream>
#include <string.h>

void simpleTest(unsigned int i) {
  unsigned int *num = new unsigned int;
  unsigned char *dec;
  unsigned int out_length;
  *num = i;

  GolombCoding *gc = new GolombCoding((unsigned char *)num, 4, 10);
  gc->encode();
  printf("Golomb estimated bit size = %li\n", gc->getBitSizeEstimation());
  dec = gc->decode(&out_length);
  printf("Decoded: %i\n", *(unsigned int *)dec);
  delete num;
  delete[] dec;
}

int main(int argc, char **argv) {
  unsigned char *input;
  unsigned char *dec;
  unsigned int *tmp_int = new unsigned int;
  unsigned char *tmp_str = new unsigned char[4];
  unsigned int out_length;
  int length;
  //simpleTest(atoi(argv[1]));

  std::ifstream in(argv[1], std::ifstream::binary);

  // get length of file
  in.seekg(0, std::ios::end);
  length = in.tellg();
  in.seekg(0, std::ios::beg);
  // allocate memory
  input = new unsigned char[length];
  // read data as a block
  in.read((char *)input, length);
  in.close();
  printf("length = %i\n", length);

  /*
  length = 8;
  input = new unsigned char[8];
  *tmp_int = 40;
  tmp_str = (unsigned char *)tmp_int;
  input[0] = tmp_str[0];
  input[1] = tmp_str[1];
  input[2] = tmp_str[2];
  input[3] = tmp_str[3];

  *tmp_int = 49;
  tmp_str = (unsigned char *)tmp_int;
  input[4] = tmp_str[0];
  input[5] = tmp_str[1];
  input[6] = tmp_str[2];
  input[7] = tmp_str[3];
  */
  GolombCoding *gc = new GolombCoding(input, length, atoi(argv[2]));
  gc->encode();
  printf("Golomb estimated bit size = %li\n", gc->getBitSizeEstimation());
/*
  dec = gc->decode(&out_length);
  printf("Decoded len %i\n", out_length);
  if (memcmp(dec, input, out_length) == 0)
    printf("yeah!\n");
*/
  delete[] dec;
  delete[] input;

  return 0;
}
